'use strict';

var ListaAlmoxarifadoController = angular.module('ListaAlmoxarifadoController', []);

ListaAlmoxarifadoController.controller('ListaAlmoxarifadoCtrl', ['$scope', '$routeParams', '$filter', 'Material', 'Almoxarifado', 'Construcao', 'CacheApp',
  ($scope, $routeParams, $filter, Material, Almoxarifado, Construcao, CacheApp) => {

    $scope.getListaAlmoxarifado = () => {
        var params = {
            IdClienteAdmin: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : undefined,
            IdConstrucao: $scope.construcao ? $scope.construcao.Id : 0,
            Insumo: $scope.pesquisa,
            paginacao: $scope.paginacao
        }
        $scope.paginacao.Load = true;
        Almoxarifado.getInsumosAlmoxarifado(params,
            (data) => {
                if (!$scope.listaAlmoxarifado)
                    $scope.listaAlmoxarifado = [];

                data.Instance.forEach((l,i) => {
                    if (!$scope.listaAlmoxarifado.some(a => a.IdAlmoxarifado == l.IdAlmoxarifado) ) {
                        l.IdCount = i;
                        l.construcao = $scope.construcao ? $scope.construcao : $scope.getObraById(l.IdConstrucao);
                        l.HtmlEditarItem = $scope.getHtmlEditarInsumo();
                        $scope.listaAlmoxarifado.push(l);
                    }
                })

                $scope.listaAlmoxarifadoALL = $scope.listaAlmoxarifado;
                $scope.paginacao.Load = false;
            }
        );
    }

    $scope.getAlmoxarifadoById = (insumo) => {
        var params = {
            IdAlmoxarifado: insumo.IdAlmoxarifado
        }
        Almoxarifado.getInsumosAlmoxarifadoById(params,
            (data) => {
                var update = data.Instance[0]
                insumo.IdMaterial = update.IdMaterial; 
                insumo.Tipo = update.Tipo; 
                insumo.TipoMaterial = update.TipoMaterial; 
                insumo.Codigo = update.Codigo; 
                insumo.Nome = update.Nome; 
                insumo.Unidade = update.Unidade;
                insumo.Valor = update.Valor; 
                insumo.Entrada = update.Entrada; 
                insumo.Saida = update.Saida; 
                insumo.Saldo = update.Saldo; 
                insumo.EstoqueMinimo = update.EstoqueMinimo; 
                insumo.Situacao = update.Situacao; 
                insumo.IdAlmoxarifadoSituacao = update.IdAlmoxarifadoSituacao;
            }
        );
    }

    $scope.salvarInsumo = (insumo) => {
        insumo.IdConstrucao = insumo.IdConstrucao ? insumo.IdConstrucao : ($scope.construcao ? $scope.construcao.Id : insumo.ObraSelecionada.Id);
        var params = {
            IdAlmoxarifado: insumo.IdAlmoxarifado,
            IdConstrucao: insumo.IdConstrucao,
            IdMaterial: insumo.IdMaterial,
            Valor: insumo.Valor,
            Entrada: insumo.Entrada,
            EstoqueMinimo: insumo.EstoqueMinimo
        };
        if (!insumo.Selecionado) {

            var material = {
                IdConstrucao: insumo.IdConstrucao,
                Id: 0,
                Tipo: insumo.TipoMaterial.Id,
                Codigo: insumo.Codigo,
                Nome: insumo.Nome,
                IdUnidade: insumo.IdUnidade,
                Valor: insumo.Valor,
                IdObraOrigem: insumo.IdConstrucao,
                Importado: insumo.Importado == 1
            };

            Material.setMaterial(insumo.IdConstrucao, material,
                (data) => {
                    insumo.IdMaterial = data.Instance[0].IdMaterial;
                    params.IdMaterial = insumo.IdMaterial;
                    Almoxarifado.setInsumoAlmoxarifado(params,
                        (result) => {
                            insumo.IdAlmoxarifado = result.Instance[0].IdAlmoxarifado
                            insumo.Editando = false;
                            insumo.Novo = false;
                            $scope.getAlmoxarifadoById(insumo);
                        }
                    );
                }
            );
        
        }
        else {
            Almoxarifado.setInsumoAlmoxarifado(params,
                (result) => {
                    insumo.IdAlmoxarifado = result.Instance[0].IdAlmoxarifado
                    insumo.Editando = false;
                    insumo.Novo = false;
                    $scope.getAlmoxarifadoById(insumo);
                }
            );
        }

    }
    
    $scope.excluirInsumo = (insumo) => {
        $scope.msgBoxPergunta(insumo.Nome, ' Confirma exclusão?'
        , () => {
            Almoxarifado.delInsumoAlmoxarifado(insumo.IdAlmoxarifado,
                (result) => {
                    var idx = $scope.listaAlmoxarifado.indexOf(insumo);
                    $scope.listaAlmoxarifado.splice(idx, 1);
                }
            );
        }
        , () => {
        });
    }
    

    $scope.adicionarInsumo = () => {
        var item = {
            IdCount: $scope.listaAlmoxarifado.length + 1,
            IdAlmoxarifado: 0,
            IdMaterial: 0,
            Codigo: '',
            Unidade: '',
            Nome: '',
            Quantidade: 0,
            Valor: 0,
            Novo: true,
            Editando: true,
            HtmlEditarItem: $scope.getHtmlEditarInsumo()
        };

        $scope.listaAlmoxarifado.unshift(item);
    }

    $scope.alterarInsumo = (insumo) => {
        insumo.Selecionado = true;
        insumo.Editando = !insumo.Editando;
    }

    $scope.cancelarInsumo = (insumo) => {
        insumo.Editando = !insumo.Editando;
        if (insumo.Novo) {
            var idx = $scope.listaAlmoxarifado.indexOf(insumo);
            $scope.listaAlmoxarifado.splice(idx, 1);
        }
    }

    $scope.setUnidadeSigla = function(insumo) {
        for (var i in $scope.listaUnidade)
            if ($scope.listaUnidade[i].Id == insumo.IdUnidade) {
                insumo.Unidade = $scope.listaUnidade[i].Sigla;
                break;
            }
    }
    $scope.getTipoMaterial = () => {
        Material.getTipoMaterial(
            (data) => {
                $scope.listaTipoMaterial = data.Instance;
            });
    }

    $scope.getListaUnidades = () => {
        Material.getListaUnidades(
            (data) => {
                $scope.listaUnidade = data.Instance;
            }
        );
    }

    /* override getLista(texto)  */
    $scope.getListaInsumo = function(texto, item) {
        item.Selecionado = false;

        var params = {
            idConstrucao: 0,
            nome: texto,
            IdClienteAdmin: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : undefined
        }
        Material.getListaBasePropria(params,
            (data) => {
                $scope.listaInsumo = [];
                var materiais = data.Instance;
                for (var i in materiais)
                    $scope.listaInsumo.push(materiais[i]);

                if ($scope.listaInsumo.length == 0)
                    item.Selecionado = false;

                var obra = $scope.construcao ? $scope.construcao : $scope.listaAlmoxarifado.filter(c => c.Novo)[0].ObraSelecionada;
                $scope.listaInsumo.sort(
                    (a, b) => {
                        return a.IdConstrucao == (obra ?  obra.Id : 0) ? -1 : (a.IdConstrucao > b.IdConstrucao ? 0 : 1)
                    }
                );
            });

    }

    /* override clickAdd()  */
    $scope.novoInsumo = () => {
    }

    /* override setSelecionado(selecionado)  */
    $scope.setSelecionadoInsumo = function(selecionado, insumo) {
        insumo.IdMaterial = selecionado.Id;
        insumo.Codigo = selecionado.Codigo;
        insumo.Nome = selecionado.Nome;
        insumo.Unidade = selecionado.UnidadeSigla;
        insumo.TipoMaterial = selecionado.Tipo;
        insumo.Valor = selecionado.Valor;

        insumo.Selecionado = true;
    }

    $scope.getHtmlEditarInsumo = () => {
        return '' +
            '<form role="form" class="form" name="formInsumo">' +
            '   <div class="col-lg-10 col-md-10 col-sm-10 col-xs-12">' +
            // '       <div class="form-group" ng-show="construcoes && insumo.Novo">' +
            // '           <div class="row">' +
            // '               <div class="col-lg-8 col-md-8 col-sm-8 col-xs-12">' +
            // '                   <div class="showMobile"><br /></div>' +
            // '                   <label>Obra</label>'+
            // '                   <select class="form-control"' +
            // '                       ng-model="insumo.ObraSelecionada"' +
            // '                       ng-options="cons.Titulo for cons in construcoes track by cons.Id" ng-required="construcoes">' +
            // '                       <option style="display:none" value=""> Selecione a obra </option>' +
            // '                   </select>' +
            // '               </div>' +
            // '           </div>' +
            // '       </div>' +
            '       <div class="form-group">' +
            '           <div class="row">' +
            '			    <div class="col-lg-8 col-md-8 col-sm-8 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '                   <label>Insumo</label>'+
            '                   <dropdowncomplete' +
            '                       ddc-placeholder="\'Digite o Insumo\'"' +
            '                       ddc-mensagemvazio="\'NENHUM INSUMO ENCONTRADO\'"' +
            '                       ddc-showcodigo="true"' +
            '                       ddc-showvalor="true"' +
            '                       ddc-hideadd="true"' +
            '                       ddc-construcao="construcao"' +
            '                       ddc-item="insumo"' +
            '                       ddc-lista="listaInsumo"' +
            '                       set-selecionado="setSelecionadoInsumo(selecionado,insumo)"' +
            '                       get-lista="getListaInsumo(texto,insumo)"' +
            '                       click-add="novoInsumo()">' +
            '                   </dropdowncomplete>' +
            '               </div>' +
            '           </div>' +
            '       </div>' +
            '       <div class="form-group">' +
            '           <div class="row">' +
            '               <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '					<label>Estoque Mínimo {{!insumo.Unidade ? "" : ("("+insumo.Unidade+")")}}</label>' +
            '					<input type="text" class="form-control" placeholder="Estoque Mínimo" ng-model="insumo.EstoqueMinimo" ui-number-mask="2" required>' +
            '               </div>' +
            '               <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12" ng-show="insumo.Novo">' +
            '                   <div class="showMobile"><br /></div>' +
            '					<label>Quantidade {{!insumo.Unidade ? "" : ("("+insumo.Unidade+")")}}</label>' +
            '					<input type="text" class="form-control" placeholder="Quantidade" ng-model="insumo.Entrada" ui-number-mask="2" required>' +
            '               </div>' +
            '               <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12" ng-show="insumo.Novo">' +
            '                   <div class="showMobile"><br /></div>' +
            '					<label>Valor Unitário (R$)</label>' +
            '					<input type="text" class="form-control" placeholder="Valor" ng-model="insumo.Valor" ui-number-mask="2" required>' +
            '               </div>' +
            '           </div>' +
            '       </div>' +
            '       <div class="form-group" ng-show="!insumo.Selecionado">' +
            '           <div class="row">' +
            '               <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12">' +
            '                   <label>Tipo Insumo</label>'+
            '                   <select class="form-control"' +
            '                       ng-model="insumo.TipoMaterial"' +
            '                       ng-options="tipo.Descricao for tipo in listaTipoMaterial track by tipo.Id" required>' +
            '                       <option style="display:none" value=""> Selecione o tipo </option>' +
            '                   </select>' +
            '               </div>' +
            '               <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12">' +
            '                   <br class="showMobile" />' +
            '                   <label>Unidade</label>'+
            '	                <select class="form-control" ng-model="insumo.IdUnidade" ng-init="insumo.IdUnidade = insumo.IdUnidade + \'\'" ng-change="setUnidadeSigla(insumo)" required>' +
            '	                    <option value="" selected disabled> Unidade de referência </option>' +
            '	                    <option ng-repeat="unidade in listaUnidade" value="{{unidade.Id}}">{{unidade.Descricao}} ({{unidade.Sigla}})</option>' +
            '	                </select>' +
            '               </div>' +
            '               <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12">' +
            '                   <br class="showMobile" />' +
            '                   <label>Código</label>'+
            '	                <input type="text" class="form-control" placeholder="Código" maxlength="20" ng-model="insumo.Codigo"/>' +
            '               </div>' +
            '           </div>' +
            '       </div>' +
            '   </div>' +
            '   <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12 text-center">' +
            '       <div class="row">' +
            '           <itemsalvar ng-click="salvarInsumo(insumo); $event.stopPropagation();" ></itemsalvar>' +
            '           <itemcancelar ng-click="cancelarInsumo(insumo); $event.stopPropagation();"></itemcancelar>' +
            '		</div>' +
            '   </div>' +
            '</form>';
    }

    $scope.getListaRetirada = (insumo) => {
        var params = {
            IdAlmoxarifado: insumo.IdAlmoxarifado
        };
        Almoxarifado.getAlocarInsumosAlmoxarifado(params, 
            (data) => {
                insumo.listaRetirada = data.Instance ? data.Instance : [];
                for (var i in insumo.listaRetirada) {
                    insumo.listaRetirada[i].IdCount = i;
                    insumo.listaRetirada[i].DataHora = CacheApp.getData($filter("date")(insumo.listaRetirada[i].DataHora, 'yyyy-MM-ddT03:05:00Z'));
                }
            }
        );
    }

    $scope.getListaEntrada = (insumo) => {
        var params = {
            IdAlmoxarifado: insumo.IdAlmoxarifado
        };
        Almoxarifado.getEntradaAlmoxarifado(params, 
            (data) => {
                insumo.listaEntrada = data.Instance ? data.Instance : [];
                for (var i in insumo.listaEntrada) {
                    insumo.listaEntrada[i].IdCount = i;
                    insumo.listaEntrada[i].DataHora = CacheApp.getData($filter("date")(insumo.listaEntrada[i].DataHora, 'yyyy-MM-ddT03:05:00Z'));
                }
            }
        );
    }

    $scope.adicionarEntrada = (insumo) => {
        var item = {
            IdCount: insumo.listaEntrada.length + 1,
            IdAlmoxarifado: insumo.IdAlmoxarifado,
            Quantidade: 0,
            Valor: 0,
            Novo: true,
            Editando: true,
            HtmlEditarItem: $scope.getHtmlEditarEntrada()
        };

        insumo.listaEntrada.unshift(item);
    }

    $scope.alterarEntrada = (entrada) => {
        entrada.HtmlEditarItem = $scope.getHtmlEditarEntrada();
        entrada.Editando = !entrada.Editando;
    }

    $scope.cancelarEntrada = (insumo,entrada) => {
        entrada.Editando = !entrada.Editando;
        if (entrada.Novo) {
            var idx = insumo.listaEntrada.indexOf(entrada);
            insumo.listaEntrada.splice(idx, 1);
        }
    }

    $scope.atualizaInfoEstoque = (insumo) => {
        var params = {
            IdConstrucao: $scope.construcao ? $scope.construcao.Id : 0,
            IdAlmoxarifado: insumo.IdAlmoxarifado
        }
        Almoxarifado.getInsumosAlmoxarifado(params,
            (data) => {
                insumo.Entrada = data.Instance[0].Entrada;
                insumo.Saida = data.Instance[0].Saida;
                insumo.IdAlmoxarifadoSituacao = data.Instance[0].IdAlmoxarifadoSituacao;
                insumo.Valor = data.Instance[0].Valor;
                insumo.Saldo = data.Instance[0].Saldo;
                insumo.Situacao = data.Instance[0].Situacao;
            }
        );
    }

    $scope.setEntradaAlmoxarifado = (insumo, entrada) => {
        var params = {
            IdAlmoxarifado: entrada.IdAlmoxarifado,
            IdEntrada: entrada.IdEntrada,
            Valor: entrada.Valor,
            Quantidade: entrada.Quantidade
        };
        Almoxarifado.setEntradaAlmoxarifado(params, 
            (data) => {
                $scope.getListaEntrada(insumo);
                $scope.atualizaInfoEstoque(insumo);
            }
        );
    }

    $scope.excluirEntrada = (insumo, entrada) => {
        $scope.msgBoxPergunta('Excluir Entrada', ' Confirma?'
        , () => {
                var params = {
                    IdAlmoxarifado: insumo.IdAlmoxarifado,
                    IdEntrada: entrada.IdEntrada
                };
                Almoxarifado.delEntradaAlmoxarifado(params, 
                    (data) => {
                        $scope.getListaEntrada(insumo);
                        $scope.atualizaInfoEstoque(insumo);
                    }
                );
            }
        , () => {
        });
    }

    $scope.getHtmlEditarEntrada = () => {
        return '<br />' +
            '<form class="form col-md-12 col-sm-12 center-block" name="formEntrada">' +
            '    <div class="form-group">' +
            '        <div class="row">' +
            '               <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '					<label>Quantidade {{!insumo.Unidade ? "" : ("("+insumo.Unidade+")")}}</label>' +
            '					<input type="text" class="form-control" placeholder="Quantidade" ng-model="entrada.Quantidade" ui-number-mask="2" required>' +
            '               </div>' +
            '               <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '					<label>Valor Unitário (R$)</label>' +
            '					<input type="text" class="form-control" placeholder="Valor" ng-model="entrada.Valor" ui-number-mask="2" required>' +
            '               </div>' +
            '           <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12 text-right">' +
            '	            <itemsalvar ng-click="!formEntrada.$invalid && setEntradaAlmoxarifado(insumo,entrada)"></itemsalvar>' +
            '	            <itemcancelar ng-click="cancelarEntrada(insumo,entrada)"></itemcancelar>' +
            '           </div>' +
            '        </div>' +
            '    </div>' +
            '</form>';
    }    

    $scope.adicionarRetirada = (insumo, realocar) => {
        var item = {
            IdCount: insumo.listaRetirada.length + 1,
            IdAlmoxarifado: insumo.IdAlmoxarifado,
            IdRetirada: 0,
            IdConstrucao: $scope.construcao ? $scope.construcao.Id : insumo.construcao.Id,
            Quantidade: 0,
            Novo: true,
            Editando: true,
            Realocar: realocar,
            HtmlEditarItem: $scope.getHtmlEditarRetirada()
        };

        insumo.listaRetirada.unshift(item);
        $scope.getEtapasConstrucao(insumo, null);
    }

    $scope.alterarRetirada = (insumo, retirada) => {
        retirada.HtmlEditarItem = $scope.getHtmlEditarRetirada();
        retirada.Editando = !retirada.Editando;
        $scope.getEtapasConstrucao(insumo, () => {
            $scope.getListaComposicao(insumo, retirada);
        });
    }

    $scope.cancelarRetirada = (insumo,retirada) => {
        retirada.Editando = !retirada.Editando;
        if (retirada.Novo) {
            var idx = insumo.listaRetirada.indexOf(retirada);
            insumo.listaRetirada.splice(idx, 1);
        }
    }

    $scope.setRetiradaAlmoxarifado = (insumo, retirada) => {
        var params = {
            IdAlmoxarifado: retirada.IdAlmoxarifado,
            IdRetirada: retirada.IdRetirada,
            IdConstrucao: retirada.Transferir ? retirada.obraSelecionada.id : undefined,
            IdEtapa: !retirada.Transferir ? (retirada.IdEtapa ? retirada.IdEtapa : undefined) : undefined,
            IdComposicao: !retirada.Transferir ? (retirada.IdComposicao ? retirada.IdComposicao : undefined) : undefined,
            Quantidade: retirada.Quantidade
        };

        if (retirada.Realocar) {
            if (retirada.Realocar.Quantidade - params.Quantidade < 0) {
                $scope.msgBoxAtencao('Atenção!','Quantidade de realocação maior que anterior.',() => {});
                return;
            }
            retirada.Realocar.Quantidade -= params.Quantidade;
            Almoxarifado.setAlocarInsumoAlmoxarifado(retirada.Realocar, 
                (data1) => {
                    if (data1.Code == 0) {
                        Almoxarifado.setAlocarInsumoAlmoxarifado(params, 
                            (data) => {
                                if (data.Code == 0) {
                                    $scope.getListaRetirada(insumo);
                                    $scope.atualizaInfoEstoque(insumo);
                                }
                                else {
                                    $scope.msgBoxAtencao('Atenção!',data.Description,() => {
                                        retirada.Realocar.Quantidade += params.Quantidade;
                                    });
                                }
                            }
                        );
                    }
                    else
                        $scope.msgBoxAtencao('Atenção!',data1.Description,() => {
                            retirada.Realocar.Quantidade += params.Quantidade;
                        });
                }            
            );
        }
        else
            Almoxarifado.setAlocarInsumoAlmoxarifado(params, 
                (data) => {
                    if (data.Code == 0) {
                        $scope.getListaRetirada(insumo);
                        $scope.atualizaInfoEstoque(insumo);
                    }
                    else
                        $scope.msgBoxAtencao('Atenção!',data.Description,() => {});
                }
            );
    }

    $scope.excluirRetirada = (insumo, retirada) => {
        $scope.msgBoxPergunta('Excluir Saída', 'Confirma?'
        , () => {
                var params = {
                    IdAlmoxarifado: insumo.IdAlmoxarifado,
                    IdRetirada: retirada.IdRetirada
                };
                Almoxarifado.delAlocarInsumoAlmoxarifado(params, 
                    (data) => {
                        $scope.getListaRetirada(insumo);
                        $scope.atualizaInfoEstoque(insumo);
                    }
                );
            }
        , () => {
        });
    }

    $scope.getHtmlEditarRetirada = () => {
        return `<br />
            <form class="form col-md-10 col-sm-10 center-block" name="formRetirada">
                <div class="form-group">
                    <div class="row">
                        <div class="col-md-10">
                            <input type="checkbox" ng-click="retirada.Transferir = !retirada.Transferir" ng-init="retirada.Transferir = false"> Transferir para outro almoxarifado <br><br>
                        </div>
                   </div>
                    <div class="row" ng-show="retirada.Transferir">
                        <div class="col-md-10">
                            <label>Obra</label><br>
                            <am-multiselect
                                multiple="false"
                                ms-selected="{{c.Titulo}}"
                                ng-model="retirada.obraSelecionada" 
                                ms-header="Selecione a obra"
                                findshow="true"
                                placeholder="Digite o nome da obra"
                                options="c.Titulo for c in almoxarifados" 
                                ng-change="retirada.IdConstrucao = retirada.obraSelecionada.Id"
                                style="cursor: pointer;"
                                block="true">
                            </am-multiselect>
                        </div>
                   </div>
                </div>
                <div class="form-group" ng-show="!retirada.Transferir">
                    <div class="row">
                        <div class="col-md-10">
                            <select class="form-control" ng-model="retirada.IdEtapa" ng-init="retirada.IdEtapa = retirada.IdEtapa + ''" ng-change="getListaComposicao(insumo, retirada)" autofocus>
                                <option value="" selected disabled> Selecione a Etapa </option>
                                <option ng-repeat="etapa in insumo.etapas" value="{{etapa.Id}}">{{etapa.Ordem + ' ' + etapa.Descricao}}</option>
                            </select>
                        </div>
                   </div>
                </div>
                <div class="form-group" ng-show="!retirada.Transferir">
                    <div class="row">
                        <div class="col-md-10">
                            <select class="form-control" ng-disabled="!insumo.composicoes" ng-model="retirada.IdComposicao" ng-init="retirada.IdComposicao = retirada.IdComposicao + ''">
                                <option value="" selected disabled> Selecione a Composição </option>
                                <option ng-repeat="composicao in insumo.composicoes" value="{{composicao.Id}}">{{composicao.Ordem + ' ' + composicao.Nome}}</option>
                            </select>
                        </div>
                    </div>
                </div>
                <div class="form-group">
                    <div class="row">
                       <div class="col-md-4">
                           <div class="input-group">
                               <input type="text" class="form-control" placeholder="Quantidade" ng-model="retirada.Quantidade" ui-number-mask="2" required>
                               <span class="input-group-addon">
                                   {{insumo.Unidade}}
                               </span>
                           </div>
                       </div>
                       <div class="col-md-6 text-right">
            	            <itemsalvar ng-click="!formRetirada.$invalid && setRetiradaAlmoxarifado(insumo,retirada)"></itemsalvar>
            	            <itemcancelar ng-click="cancelarRetirada(insumo,retirada)"></itemcancelar>
                       </div>
                    </div>
                </div>
            </form>`;
    }

    $scope.getAlmoxarifados = () => {
        $scope.almoxarifados = $scope.construcoes.filter(c => !$scope.construcao || c.Id !== $scope.construcao.Id);
    }

    $scope.getEtapasConstrucao = (insumo, callBack) => {
        if (insumo.etapas) return;
        insumo.etapas = [];
        Construcao.getEtapasConstrucao($scope.construcao ? $scope.construcao.Id : insumo.construcao.Id,
            (data) => {
                insumo.etapas = data.Instance;
                if (callBack)
                    callBack();
            });
    }

    $scope.getListaComposicao = (insumo, retirada) => {
        if (!retirada.IdEtapa) return;

        for (var i in insumo.etapas)
            if (insumo.etapas[i].Id == retirada.IdEtapa) {
                retirada.Etapa = insumo.etapas[i].Descricao;
                break;
            }

        Material.getListaMaterialAvanco(
            $scope.construcao ? $scope.construcao.Id : insumo.construcao.Id,
            retirada.IdEtapa,
            '',
            (data) => {
                insumo.composicoes = data.Instance;
            }
        );
    }

    $scope.changeListaComposicao = (insumo) => {
        for (var i in insumo.composicoes)
            if (insumo.composicoes[i].Id == insumo.IdComposicao) {
                insumo.Composicao = insumo.composicoes[i].Nome;
                break;
            }
    }

    $scope.getListaConstrucao = (callBack) => {
        var params = {
            permissao: 'GET_ALMOXARIFADO',
            refresh: $scope.refreshObra ? true: false
        }
        $scope.getListaObraCache(params, 
            (obra)=> {
                $scope.refreshObra = undefined
                $scope.construcoes = obra
                callBack()
            }
        )
    }

    $scope.filtraObra = (obra) => {
        if (obra && obra.id) {
            $scope.setObraSelecionada($scope.construcoes.filter(c => c.Id == obra.id)[0])
        }
        else {
            $scope.listaAlmoxarifado = undefined;
            $scope.construcao = undefined;
            CacheApp.delConstrucao();
            $scope.listaRelatorio = [];
        }
    }

    $scope.setObraSelecionada = (obra) => {
        $scope.listaAlmoxarifado = undefined;
        $scope.construcao = obra;
        CacheApp.setConstrucao($scope.construcao);
        $scope.HtmlManterObra = undefined

        $scope.listaRelatorio = [];
        $scope.listaRelatorio = $scope.reportList.filter(r => obra.Acessos.indexOf(r.Permissao) >= 0);
        $scope.loadPage(true);
    }

    $scope.editarObra = () => {
        if (!$scope.HtmlManterObra)
            $scope.HtmlManterObra = `
                <manterobra mo-obra="construcao">
                </manterobra>
            `;
        $scope.openObra = !$scope.openObra;
        if (!$scope.openObra && $scope.construcao.Novo)
            $scope.loadObra()
    }

    $scope.adicionarObra = () => {
        if ($scope.sessao.TipoPlano == 3 && $scope.construcoes && $scope.construcoes.length > 2) {
            CacheApp.msgBoxAcessoPremium();
            return;
        }

        $scope.construcao = { Tipo: 0, Dono: true, Novo: true }
        $scope.editarObra()
    }

    $scope.salvarObra = () => {
        $rootScope.$broadcast('salvarObra', {});
    }

    $scope.$on('refreshComboObra', (events,args) => {
        $scope.refreshObra = true;
        $scope.loadObra();
    })

    $scope.loadObra = () => {
        $scope.ObraSelecionada = CacheApp.getConstrucao()
        CacheApp.delConstrucao()
        $scope.AtualizaConstrucao()
        $scope.getListaConstrucao(()=>{
            if ($scope.ObraSelecionada && $scope.construcoes.some(c => c.Id == $scope.ObraSelecionada.Id)) {
                $scope.ObraSelecionada = $scope.construcoes.filter(c => c.Id == $scope.ObraSelecionada.Id)[0]
                $scope.listaSelecao = {
                    id: $scope.ObraSelecionada.Id, 
                    model: $scope.ObraSelecionada.Titulo, 
                    label: $scope.ObraSelecionada.Titulo,
                    checked: true
                }
                $scope.setObraSelecionada($scope.ObraSelecionada)
            }
            else {
                $scope.ObraSelecionada = undefined
                $scope.construcao = undefined
                $scope.listaAlmoxarifado = []
            }
        })
    }

    $scope.getObraById = (IdObra) => {
        var obra = {};
        $scope.construcoes.every(o => {
            obra = o;
            return !(o.Id == IdObra);
        });
        return obra;
    }

    $scope.filtraTipo = () => {
        $scope.listaAlmoxarifado = 
            $scope.filtro.Tipo.Id == 0 ? 
                $scope.listaAlmoxarifadoALL :
                    $scope.listaAlmoxarifadoALL.filter(
                        s => {
                            return $scope.filtro.Tipo.Id == s.Tipo;
                        }
                    );
    }

    $scope.filtroSituacao = () => {
        $scope.listaAlmoxarifado = 
            $scope.filtro.Situacao.Id == 0 ? 
                $scope.listaAlmoxarifadoALL :
                    $scope.listaAlmoxarifadoALL.filter(
                        s => {
                            return $scope.filtro.Situacao.Id == s.IdAlmoxarifadoSituacao;
                        }
                    );
    }

    $scope.getSituacaoAlmoxarifado = () => {
        Almoxarifado.getSituacaoAlmoxarifado(
            (data) => {
                $scope.listaSituacao = data.Instance;
                $scope.listaSituacao.unshift({Id: 0, Nome: 'TODOS'});
            }
        );
    }

    $scope.loadPage = (loadObra) => {
        if (loadObra) {
            $scope.construcao = CacheApp.getConstrucao();
        }

        $scope.inicializaPaginacao();

        $scope.getTipoMaterial();
        $scope.getListaUnidades();

        $scope.getListaAlmoxarifado();
        $scope.getAlmoxarifados();
        $scope.getSituacaoAlmoxarifado();

        $scope.filtro = {
            Situacao: {Id: 0, Nome: 'TODOS'}
        };

    }

    $scope.aplicaFiltro = (e) => {
        clearTimeout($scope.timer); 
        $scope.timer = setTimeout( () => {
            $scope.inicializaPaginacao(); 
            $scope.getListaAlmoxarifado();
        }, 1000);
    }

    $scope.inicializaPaginacao = () => {
        $scope.listaAlmoxarifado = undefined;
        $scope.paginacao = {
            Index: 0,
            Pages: 20
        };
    }

    $scope.AcessoAndroid($routeParams, (sim) => {
        $scope.AcessoMobile = sim;
        $scope.sessao = CacheApp.getSessao();
        
        $scope.reportList = [
            { Id: 0, Descricao: 'Lista Almoxarifado', Permissao: 'GET_ALMOXARIFADO', Url: 'relatorioalmoxarifado' }
        ];

        if ($routeParams.from == 'geral')
            $scope.getListaConstrucao(
                () => {
                    $scope.loadObra()
                }
            );
        else
            $scope.loadPage(true);
        }
    );


  }]);
